#
#     Copyright (C) 2006
#
#     This code is distributed under the terms and conditions of the
#     CCP4 licence agreement as `Part 1' (Annex 2) software.
#     A copy of the CCP4 licence can be obtained by writing to the
#     CCP4 Secretary, Daresbury Laboratory, Warrington WA4 4AD, UK.
#
#====================================================================
# Commands for Def & SQLite backend - DBcommand.py
#
# Wanjuan Yang March 06
#
#====================================================================

#CCP4i_cvs_Id $Id: DBcommand.py,v 1.25 2007/02/14 17:02:12 wy45 Exp $

######################################################################


__version__ = "$Revision: 1.25 $"

#######################################################################
# Import modules that this module depends on
#######################################################################
import xml.dom.minidom
import xml.sax.saxutils as su
import exceptions


try:
    import ccp4i
    from manager import *
except exceptions.Exception,x:
    print "Not support .def backend"

def do_sql_newrecord_command(mydb,command,argu):
	if command == 'NewRecord':
	    try:
               if len(argu) < 1:
                   result = 'Argument should be: tablename'
                   status = 'ERROR'
               else:
                   table = argu[0].childNodes[0].data
                   
                   no = mydb.new_record(table)
                   if 'DB exception: ' not in no:
		       status = 'OK'
                   else:
		       status = 'ERROR'
                   result = no

            except exceptions.Exception,x:
                print '# Handler message: catch exception:',str(x)
                status = 'ERROR'
                result = 'no such database:' + str(x)
	    value = [result,status,table,no]
	    return value
		    
	elif command == 'NewProject_sql':
	    no = 0  # initial no
            try:
                if len(argu) < 1:
                    result = 'Argument should be: projectname'
                    status ='ERROR'
                else:
                    projectname = argu[0].childNodes[0].data
            
                    #check if there is the same projectname already
                    condition = 'where ProjectName = \''+projectname+'\''
                    a = mydb.get_table_primary_key('Project',condition)
                    if a == []:		
                        no = mydb.new_record('Project')
                        mydb.set_table_attribute('Project',no,'ProjectName',projectname)
                        result = no
                        status = 'OK'
                    elif a == 'DB not open yet' or 'error' in a:
                        result = a
                        status = 'ERROR'
                    else:
                        result = 'Project exists'
                        status = 'ERROR'
		
            except exceptions.Exception,x:
                print '# Handler message: catch exception when New porject:',str(x)
                status = 'ERROR'
                result = 'no such database:' + str(x)
	    
	    value = [result,status,'Project',no]
            return value

        elif command == 'NewJob_sql':
	    no = 0 # initial no
            try:
                if len(argu) < 1:
                    result = 'Arugment should be: projectname'
                    status = 'ERROR'
                else:
                    projectname = argu[0].childNodes[0].data
                    condition = 'where ProjectName = \''+projectname+'\''
                    pid = mydb.get_table_primary_key('Project',condition)
	    
                    if pid !=  'DB not open yet' and 'error' not in pid:		
			no = mydb.new_record('Job')
                        
			mydb.set_table_attribute('Job',no,'ProjectId',pid)
			result = no
			status = 'OK'
                    else:
			result = 'no such project'
			status = 'ERROR'
	    
            except exceptions.Exception,x:
                print '# Handler message: catch exception when New job:',str(x)
                status = 'ERROR'
                result = 'no such database:' + str(x)
	    
	    value = [result,status,'Job',no]
            return value
    
def do_sql_setdata_command(mydb,command,argu):

	if command == 'SetJobData_sql':
            try:
                argu_num = len(argu)
                if argu_num < 3:
                    result = 'Arguments should be : jobid item value [item1 value1 ...]'
                    status = 'ERROR'
                else:
                    result = []
                    jobid = argu[0].childNodes[0].data
                    for i in range((argu_num-1)/2):
                        item = argu[i*2+1].childNodes[0].data
                        value = argu[i*2+2].childNodes[0].data
            
                        result.append(mydb.set_table_attribute('Job',jobid,item,value)) 
                        #check the result and assign status 
                    for value in result:
                        if False in value:
                            status = 'ERROR'
                            break
                    else:
                        status = 'OK'

            except exceptions.Exception,x:
                print '# Handler message: catch exception when set data:',str(x)
                status = 'ERROR'
                result = 'catch exception: '+ str(x)
	
	    value = [result,status,'Job',jobid]
            return value

        elif command == 'SetData':
	    try:
	        argu_num = len(argu)
                if argu_num < 4:
                    result = 'Arguments should be: table recordid attribute value [attribute1 value2...]'
                    status ='ERROR'
                else:
                    table = argu[0].childNodes[0].data
                    id = argu[1].childNodes[0].data
                    result = []
                    for i in range((argu_num-2)/2):
                        attribute = argu[i*2+2].childNodes[0].data
                        value = argu[i*2+3].childNodes[0].data
                        result.append(mydb.set_table_attribute(table,id,attribute,value))
                    #check the result and assign status 
                    for value in result:
                        if False in value:
                            status = 'ERROR'
                            break
                    else:
                        status = 'OK'

            except exceptions.Exception,x:
                print '# Handler message: catch exception:',str(x)
                status = 'ERROR'
                result = 'no such database:' + str(x)
            
	    value = [result,status,table,id]
            return value
		
def do_sql_command(mydb,command,argu,id):
	
	if command == 'GetJobData_sql':
            try:
                argu_num = len(argu)
                if argu_num < 2:
                    result = 'Arguments should be: jobid item [item1 ...]'
                    status = 'ERROR'
                else:
                    jobid = argu[0].childNodes[0].data
                    result = []

                    for i in range(argu_num-1):
                        item = argu[i+1].childNodes[0].data
                        result.append(mydb.get_table_attribute('Job',jobid,item))

                        # check the result and assign the status
                    for value in result: 
                        if 'error' in value or value == 'DB not open yet':
                            status = 'ERROR'
                            break
                    else:
                        status = 'ERROR'

            except exceptions.Exception,x:
                print '# Handler message: catch exception when get data:',str(x)
                status = 'ERROR'
                result = 'no such database:' + str(x)
            
            response = response_wrapper(status,result,id)
            return response    

        elif command == 'GetProjectList':
	    try:
	        result = mydb.GetProjectList()
		if result != 'error' and result !='DB not open yet':
                    status = 'OK'
                else:
                    status = 'ERROR'

            except exceptions.Exception,x:
                print '# Handler message: catch exception when set data:',str(x)
                status = 'ERROR'
                result = 'no such database:' + str(x)
            
            response = response_wrapper(status,result,id)
            return response

        
        elif command == 'GetJobList':
	    try:
                if len(argu) < 1:
                    result = 'Argument should be: projectname'
                    status = 'ERROR'
                else:
                    projectname = argu[0].childNodes[0].data
                    projectid = mydb.GetProjectId(projectname)
                    if projectid != 'error' and projectid !='DB not open yet':
		
		        result = mydb.GetJobList(projectid)
		        if result != 'error' and result !='DB not open yet':
                            status = 'OK'
                        else:
			    status = 'ERROR'

                    else:
		        result = projectid
			status = 'ERROR'
			
            except exceptions.Exception,x:
                print '# Handler message: catch exception:',str(x)
                status = 'ERROR'
                result = 'no such database:' + str(x)
            
            response = response_wrapper(status,result,id)
            return response
    
        elif command == 'GetTableSchema':
	    try:
                if len(argu) < 1:
                    result = 'Argument should be: tablename'
                    status = 'ERROR'
                else:
                    table = argu[0].childNodes[0].data
                    result = mydb.GetTableSchema(table)
	
                    if result !='no such table':
			status = 'OK'
                    else:
			status = 'ERROR'
			
            except exceptions.Exception,x:
                print '# Handler message: catch exception:',str(x)
                status = 'ERROR'
                result = str(x)
            
            response = response_wrapper(status,result,id)
            return response 
        
        elif command == 'GetRowofTable':
	    try:
                if len(argu) < 2:
                    result = 'Argument should be: table recordid'
                    status = 'ERROR'
                else:
                    table = argu[0].childNodes[0].data
                    tid = argu[1].childNodes[0].data
                    result = mydb.GetRowofTable(table,tid)
	
                    if result !='DB not open' or 'error' not in result:
			status = 'OK'
                    else:
			status = 'ERROR'
			
            except exceptions.Exception,x:
                print '# Handler message: catch exception:',str(x)
                status = 'ERROR'
                result = str(x)
            
            response = response_wrapper(status,result,id)
            return response
    
        elif command == 'GetData':
	    try:
	        argu_num = len(argu)
                if argu_num < 3:
                    result = 'Arguments should be: tablename recordid attribute [attribute2 ...]'
                    status = 'ERROR'
                else:
                    table = argu[0].childNodes[0].data
                    id = argu[1].childNodes[0].data
                    result = []

                    for i in range(argu_num-2):
                        attribute = argu[i+2].childNodes[0].data
		
                    result.append(mydb.get_table_attribute(table,id,attribute))
            
                    if result != 'error' and result !='DB not open yet' and result != []:
                        status = 'OK'
                    else:
                        status = 'ERROR'

            except exceptions.Exception,x:
                print '# Handler message: catch exception when set data:',str(x)
                status = 'ERROR'
                result = 'no such database:' + str(x)
            
            response = response_wrapper(status,result,id)
	    
            return response    
    
        elif command == 'GetProjectId':
	    try:
                if len(argu) < 1:
                    result = 'Argument should be: projectname'
                    status = 'ERROR'
                else:
                    projectname = argu[0].childNodes[0].data
                    result = mydb.GetProjectId(projectname)
                    if result != 'error' and result !='DB not open yet' and result != []:
                        status = 'OK'
                    else:
                        status = 'ERROR'

            except exceptions.Exception,x:
                print '# Handler message: catch exception when set data:',str(x)
                status = 'ERROR'
                result = 'no such database:' + str(x)
            
            response = response_wrapper(status,result,id)
            return response    
    
        elif command == 'CloseDB_sql':
            try:
                result = mydb.CloseDB()
            
            except exceptions.Exception,x:
                print '# Handler message: catch exception when close DB:',str(x)
                status = 'ERROR'
                result = 'no such database:' + str(x)

            if result == True:
                status = 'OK'
            else:
                status = 'ERROR'
                
            response = response_wrapper(status,result,id)
            print '# Handler message: response is: ', response
            return response


def do_defCommand(mydb,command,argu,id):

       if command == 'Updatetime':
           try:
               # get parameter
               if len(argu) < 2:
                   result = 'Arguments should be: projectname jobid'
                   status = 'ERROR'
               else:
                   jobid = argu[1].childNodes[0].data

                   # call db API
                   result = mydb.updatetime(int(jobid))
           
           except exceptions.Exception,e:
               print '# Handler message: catch exception when update time:', str(e)

               result = 'Handler exception: '+str(e)

           if result == True:
               status = 'OK'
           else:
               status = 'ERROR'
               
           response = response_wrapper(status,result,id)
           return response
   
       elif command == 'GetNJOB':
           try:
               # call db API
               result = mydb.njobs()
               if result != -1:
                   status = 'OK'
               else:
                   status ='ERROR'
                   result = 'data not loaded'
                   
           except exceptions.Exception,e:
               print '# Handler message: catch exception when GetNJOB:', str(e)
               status = 'ERROR'
               result = 'Handler exception: '+str(e)
               
           
           response = response_wrapper(status,result,id)
           return response
   
       elif command == 'DbGetData':
           try:
               # get parameter
               argu_num = len(argu)
               if argu_num < 3:
                   result = 'Arguments should be: projectname jobid item [ item2...]'
                   ststus = 'ERROR'
               else:
                   jobid = argu[1].childNodes[0].data
                   result = []
                   for i in range(argu_num-2):
               
                       item = argu[i+2].childNodes[0].data

                       # call db API
                       result.append(mydb.getdata(int(jobid),item))
                       status = 'OK'
           except exceptions.Exception,e:
               print '# Handler message: catch exception when get data:', str(e)
               status = 'ERROR'
               result = 'Handler exception: '+str(e)

           response = response_wrapper(status,result,id)

           return response

       elif command == 'DbItemExists':
           try:
               # get parameter
               if len(argu) < 3:
                   result = 'Arguments should be: projectname jobid item'
                   status = 'ERROR'
               else:
                   jobid = argu[1].childNodes[0].data
                   item = argu[2].childNodes[0].data
                   # call db API
                   result = mydb.itemexists(int(jobid),item)
           
           except exceptions.Exception,e:
               print '# Handler message: catch exception when check item exists:', str(e)
               status = 'ERROR'
               result = 'Handler exception: '+str(e)

           if result == True:
               status = 'OK'
           else:
               status = 'ERROR'
               
           response = response_wrapper(status,result,id)

           return response
    
       elif command == 'DbSelectRecords':
           try:
               # get parameter
               if len(argu) < 3:
                   result = 'Arguments should be: projectname item pattern'
                   status = 'ERROR'
               else:
                   item = argu[1].childNodes[0].data
                   pattern = argu[2].childNodes[0].data
                   # call db API
                   result = mydb.selectjobs(item,pattern)
                   status = 'OK'
           except exceptions.Exception,e:
               print '# Handler message: catch exception when select record:', str(e)
               status = 'ERROR'
               result = 'Handler exception: '+str(e)

           response = response_wrapper(status,result,id)
           return response

       elif command == 'ListJobs':
           try:
               # call db API
               result = mydb.listjobs()
               status = 'OK'
	   
           except exceptions.Exception,e:
               print '# Handler message: catch exception when listjob:', str(e)
               status = 'ERROR'
               result = 'Handler exception: '+str(e)

           response = response_wrapper(status,result,id)
           return response 

       elif command == 'DbReturnRecord':
           try:               
               if len(argu) < 4:
                   result = 'Arguments should be: projectname joblist itemlist formatlist'
                   status = 'ERROR'
               else:
                   joblist = get_argument_list(argu[1])

                   itemlist = get_argument_list(argu[2])
                   
                   formatlist = get_argument_list(argu[3])
            
                   result = mydb.describe(joblist,itemlist,formatlist)
                   
                   status = 'OK'
           except exceptions.Exception,e:
               print '# Handler message: catch exception when get description:', str(e)
               status = 'ERROR'
               result = 'Handler exception: '+str(e)

           response = response_wrapper(status,result,id)
           
           return response


       elif command == 'DbGetListofRecords':
           try:
               if len(argu) < 3:
                   result = 'Arguments should be: projectname joblist itemlist'
                   status = 'ERROR'
               else:
                   joblist = get_argument_list(argu[1])      
             
                   itemlist = get_argument_list(argu[2])
                   result = [] # store a list of records

                   if joblist != [] and itemlist != []:
                       for i in joblist:
                           record = [] # store a single record
                           for j in itemlist:
                               if mydb.itemexists(int(i),j):
                                   record.append(mydb.getdata(int(i),j))
                                   status = 'OK'
                               else:
                                   record = ' item '+j+' not exist.'
                                   status = 'ERROR'
                                   break
                           result.append(record)
               
                   else:
                       result = 'Job ids or items are not specified.'
                       status = 'ERROR'
           except exceptions.Exception,e:
               print '# Handler message: catch exception:', str(e)
               status = 'ERROR'
               result = 'Handler exception: '+str(e)

           response = response_wrapper(status,result,id)
           
           return response
   
       elif command == 'GetNextJobList':
           try:
               if len(argu) < 2:
                   result = 'Arguments should be: projectname job'
                   status = 'ERROR'
               else:
                   job = argu[1].childNodes[0].data
	       
                   dbhistory = ccp4i.history(mydb,ProjectManager.directory)
	       
                   dbhistory.construct()
	       
                   result = dbhistory.childrenof(int(job))
                   status = 'OK'
	       
           except exceptions.Exception,e:
	       print '# Handler message: catch exception:', str(e)
               status = 'ERROR'
               result = 'Handler exception: '+str(e)

           response = response_wrapper(status,result,id)
           
           return response

       elif command == 'GetAllLinks':
	   try:	       
	       dbhistory = ccp4i.history(mydb,ProjectManager.directory)
	       dbhistory.construct()
	       joblist = mydb.listjobs()
	       historylink = []
	       for job in joblist:
	            nextjobs = dbhistory.childrenof(job)
		    for child in nextjobs:
		        alink = [job,child]
			historylink.append(alink)

	       result = historylink
               status = 'OK'
                
           except exceptions.Exception,e:
	       print '# Handler message: catch exception:', str(e)
               status = 'ERROR'
               result = 'Handler exception: '+str(e)

           response = response_wrapper(status,result,id)
           
           return response
          
       elif command == 'GetLinks':
           try:
               if len(argu) < 2:
                   result = 'Arguments should be: projectname joblist'
                   status = 'ERROR'
               else:
                   dbhistory = ccp4i.history(mydb,ProjectManager.directory)
               
                   dbhistory.construct()
               
                   joblist = get_argument_list(argu[1])
           
                   if joblist != []:
                       historylink = []
                       for job in joblist:
                           nextjobs = dbhistory.childrenof(int(job))
                       
                           for child in nextjobs:
                               alink = [job,child]
                               historylink.append(alink)

                       result = historylink
                       status = 'OK'
                   else:
                       result = []
                       status ='OK'
                    
           except exceptions.Exception,e:
	       print '# Handler message: catch exception when GetLinks:', str(e)
               status = 'ERROR'
               result = 'Handler exception: '+str(e)

           response = response_wrapper(status,result,id)
           
           return response

       elif command == 'GetAllChildren':
           try:
               if len(argu) < 2:
                   result = 'Arguments should be: projectname jobid'
                   status = 'ERROR'
               else:
                   dbhistory = ccp4i.history(mydb,ProjectManager.directory)
                   dbhistory.construct()
                   jobid = argu[1].childNodes[0].data
                   result = dbhistory.allchildrenof(int(jobid),[])

                   status = 'OK'

           except exceptions.Exception,e:
	       print '# Handler message: catch exception:', str(e)
               status = 'ERROR'
               result = 'Handler exception: '+str(e)

           response = response_wrapper(status,result,id)
           
           return response

       
       elif command == 'GetAllParents':
           try:
               if len(argu) < 2:
                   result = 'Arguments should be: projectname jobid'
                   status = 'ERROR'
               else:
                   dbhistory = ccp4i.history(mydb,ProjectManager.directory)
                   dbhistory.construct()
                   jobid = argu[1].childNodes[0].data
                   result = dbhistory.allparentsof(int(jobid),[])

                   status = 'OK'

           except exceptions.Exception,e:
	       print '# Handler message: catch exception:', str(e)
               status = 'ERROR'
               result = 'Handler exception: '+str(e)

           response = response_wrapper(status,result,id)
           
           return response

       elif command == 'GetChildren':
           try:
               if len(argu) < 2:
                   result = 'Arguments should be: projectname jobid'
                   status = 'ERROR'
               else:
                   dbhistory = ccp4i.history(mydb,ProjectManager.directory)
                   dbhistory.construct()
                   jobid = argu[1].childNodes[0].data
                   result = dbhistory.childrenof(int(jobid))

                   status = 'OK'

           except exceptions.Exception,e:
	       print '# Handler message: catch exception:', str(e)
               status = 'ERROR'
               result = 'Handler exception: '+str(e)

           response = response_wrapper(status,result,id)
           
           return response
       
       elif command == 'GetParents':
           try:
               if len(argu) < 2:
                   result = 'Arguments should be: projectname jobid'
                   status = 'ERROR'
               else:
                   dbhistory = ccp4i.history(mydb,ProjectManager.directory)
                   dbhistory.construct()
                   jobid = argu[1].childNodes[0].data
                   result = dbhistory.parentsof(int(jobid))

                   status = 'OK'

           except exceptions.Exception,e:
	       print '# Handler message: catch exception:', str(e)
               status = 'ERROR'
               result = 'Handler exception: '+str(e)

           response = response_wrapper(status,result,id)
           
           return response
       
       else:
           status = 'FAILED'
           result = 'No implement yet'
           response = response_wrapper(status,result,id)
           return response


def get_argument_list(arguTag):

    ''' if argument is a list, given the xml Tag, return a list'''
    list = arguTag.childNodes
    items = list[0].childNodes
    argumentlist = []
    for item in items:
        argumentlist.append(item.childNodes[0].data)
    return argumentlist

